function love.load()

    rect = {w=80,h=80,indrag=false,inside=false,diffx=0,diffy=0}

    dragTimer = 0

    lg = love.graphics
    lm = love.mouse
    
    gem = {sprite = lg.newImage('assets/sprites/gem.png'),x=400,y=300,rot=0,scale=3}

    mouse = {x,y}

    overlap = false

end

function love.update(dt)

    dragTimer = dragTimer + dt

    mouse.x,mouse.y = lm.getPosition()

    if (mouse.x>gem.x+8 and mouse.x<gem.x+rect.w+8) and (mouse.y>gem.y+8 and mouse.y<gem.y+rect.h+8) then 
        rect.inside = true 
    else
        rect.indrag = false
    end 

    if rect.inside == true and gem.scale < 4 then
        gem.scale = gem.scale + 0.3
    elseif rect.inside == false and gem.scale > 3 then
        gem.scale = gem.scale - 0.3
    end

    if lm.isDown(1) and rect.indrag == false then 
		mouse.x,mouse.y = lm.getPosition()
		
		if (mouse.x>gem.x+8 and mouse.x<gem.x+rect.w+8) and (mouse.y>gem.y+8 and mouse.y<gem.y+rect.h+8) then 
			rect.indrag = true 
			rect.diffx , rect.diffy = (mouse.x-gem.x) , (mouse.y-gem.y)
		end 
	
	elseif lm.isDown(1) == false then
		rect.indrag = false 
	end 

	
	if rect.indrag == true then
		mouse.x,mouse.y = lm.getPosition()
		gem.x,gem.y = mouse.x-rect.diffx , mouse.y-rect.diffy
	end 

end

function love.draw()
    gem.sprite:setFilter("nearest", "nearest")
    lg.rectangle("fill", gem.x+8, gem.y+8, rect.w, rect.h)

end